# Drumpad

This example demonstrates how to integrate Python or C++ code in a Qt Design Studio
project. The UI layout and appearance is defined in QML language, while part of
the application logic is implemented in Python. Qt Design Studio can be used to
modify the UI layout and appearance easily.

![Screenshot of the program](Drumpad.png)

The project shows a drumpad screen that can be used to play different sound
effects. The screen is composed of a responsive grid of buttons, each
playing a different sound. In addition, a waveform display shows the audio
amplitude over time.

## Running the example

The example can be executed using Python or C++. For the latter, Qt Design Studio can generate CMake
required files.

For running the code using Python, the only requirement is having a interpreter installed.
[Link to official Python downloads](https://www.python.org/downloads/).

Then it can be easily executed from the command line:

```bash
# Assuming the working directory is the examples/Drumpad/Python folder:
python main.py
```
